#property copyright "*"
#property link      "*"
#property version   "1.00"
#property strict
#property indicator_separate_window
#property indicator_buffers 4


#property indicator_label1  "div"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrSilver
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1

#property indicator_label2  "upper"
#property indicator_type2   DRAW_LINE
#property indicator_color2  clrDodgerBlue
#property indicator_style2  STYLE_SOLID
#property indicator_width2  1

#property indicator_label3  "lower"
#property indicator_type3   DRAW_LINE
#property indicator_color3  clrPink
#property indicator_style3  STYLE_SOLID
#property indicator_width3  1

#property indicator_label4  "both"
#property indicator_type4   DRAW_LINE
#property indicator_color4  clrKhaki
#property indicator_style4  STYLE_SOLID
#property indicator_width4  1



extern   int         MAPeriod                =  14;      
//  
extern   int         MAMethod                =  0;       
//  : 0-SMA, 1-EMA, 2-SMMA, 3-LWMA
extern   int         MAPrice                 =  0;       
//  : 0-Close, 1-Open, 2-High, 3-Low, 4-Median, 5-Typical, 6-Weighted
extern   int         MAShift                 =  0;       
//  
extern   int         Delta                   =  10;
//    
extern   int         AverPeriod              =  10;
//    
extern   bool        AfterCross              =  false;
//          


double         Div[];

double         UpperValue[];
double         LowerValue[];
double         BothValue[];

double         UpperMax[];
double         LowerMax[];

double         UpperBufer[];
double         UpperBuferCount[];
   
double         LowerBufer[];
double         LowerBuferCount[];
   
double         BothBufer[];
double         BothBuferCount[];

double         LastDir[];

int z,p,d;
double usum,lsum,bsum;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit(){

   IndicatorBuffers(13);

   SetIndexBuffer(0,Div);   

   SetIndexBuffer(1,UpperValue);
   SetIndexBuffer(2,LowerValue);   
   SetIndexBuffer(3,BothValue);

   SetIndexBuffer(4,UpperMax);
   SetIndexEmptyValue(4,0);
   
   SetIndexBuffer(5,LowerMax);
   SetIndexEmptyValue(5,0);
   
   
   
   SetIndexBuffer(6,UpperBufer);
   SetIndexEmptyValue(6,0);
   
   SetIndexBuffer(7,UpperBuferCount);   
   SetIndexEmptyValue(7,0);
   
   
   
   SetIndexBuffer(8,LowerBufer);
   SetIndexEmptyValue(8,0);
   
   SetIndexBuffer(9,LowerBuferCount);      
   SetIndexEmptyValue(9,0);
   
   
   
   SetIndexBuffer(10,BothBufer);
   SetIndexEmptyValue(10,0);
   
   SetIndexBuffer(11,BothBuferCount);    
   SetIndexEmptyValue(11,0);
   
   SetIndexBuffer(12,LastDir);    
   SetIndexEmptyValue(12,0);   
   
   
   
   
   SetIndexLabel(0,"Close minus MA");
   SetIndexLabel(1,"Upper Average");   
   SetIndexLabel(2,"Lower Average");      
   SetIndexLabel(3,"Both Average");      
   

   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]){

   int limit=rates_total-prev_calculated;

   if(prev_calculated==0){
      limit--;
      limit--;
   }
   
   for(int i=limit;i>=0;i--){

      //       
      UpperMax[i]=UpperMax[i+1];
      LowerMax[i]=LowerMax[i+1];
      UpperBuferCount[i]=UpperBuferCount[i+1];
      LowerBuferCount[i]=LowerBuferCount[i+1];
      BothBuferCount[i]=BothBuferCount[i+1]; 
      LastDir[i]=LastDir[i+1];     

      // 
      double ma0=iMA(NULL,0,MAPeriod,MAShift,MAMethod,MAPrice,i);
      double ma1=iMA(NULL,0,MAPeriod,MAShift,MAMethod,MAPrice,i+1);
      
      if(ma1==0 || ma1==EMPTY_VALUE){
         continue;
      }
      
      // div

      Div[i]=Close[i]-ma0;
      
      //  
      if(Close[i]>ma0){
         if(Close[i+1]<=ma1){ //    
            //    
            UpperMax[i]=0;
            //    
            if(LowerMax[i]>=Point*Delta){
               //    
               
               //  
               LowerBuferCount[i]++;
               z=(int)(Bars-LowerBuferCount[i]);
               LowerBufer[z]=LowerMax[i];
               
               //    
               BothBuferCount[i]++;
               z=(int)(Bars-BothBuferCount[i]);
               BothBufer[z]=LowerMax[i];               
               
            }
         }
         //   
         UpperMax[i]=MathMax(UpperMax[i],Close[i]-ma0);
         LastDir[i]=1;
      }
      
      //  
      if(Close[i]<ma0){
         if(Close[i+1]>=ma1){ //    
            //    
            LowerMax[i]=0;
            //    
            if(UpperMax[i]>=Point*Delta){
               //    
               
               //  
               UpperBuferCount[i]++;
               z=(int)(Bars-UpperBuferCount[i]);
               UpperBufer[z]=UpperMax[i];
               
               //    
               BothBuferCount[i]++;
               z=(int)(Bars-BothBuferCount[i]);
               BothBufer[z]=UpperMax[i];                   
               
            }            
         }
         //   
         LowerMax[i]=MathMax(LowerMax[i],ma0-Close[i]);  
         LastDir[i]=-1;       
      }  
      
      //
      
      //     
      LowerValue[i]=0;
      UpperValue[i]=0;
      BothValue[i]=0;
      
      //  

      //   
      //if(LowerBuferCount[i]>=AverPeriod){
      
         d=0;
         z=(int)(Bars-LowerBuferCount[i]); //       
         p=z+AverPeriod; //       
         
         lsum=0; //  
         
         if(!AfterCross){ //        
            if(LastDir[i]==-1){ //     
               if(LowerMax[i]>=Point*Delta){
                  lsum=LowerMax[i]; //  
                  p--; //    
                  d++;
               }
            }
         }
         
         p=MathMin(Bars,p);
         for(int j=z;j<p;j++){
            lsum+=LowerBufer[j];
            d++;
         }
         
         if(d>0){
            LowerValue[i]=-lsum/d;
         }
      //}
      
      //  
      //if(UpperBuferCount[i]>=AverPeriod){
      
         d=0;
         z=(int)(Bars-UpperBuferCount[i]);
         p=z+AverPeriod;
         usum=0;
         
         if(!AfterCross){ //        
            if(LastDir[i]==1){ //     
               if(UpperMax[i]>=Point*Delta){
                  usum=UpperMax[i]; //  
                  p--; //    
                  d++;
               }
            }
         }            
         
         p=MathMin(Bars,p);
         for(int j=z;j<p;j++){
            usum+=UpperBufer[j];
            d++;
         }
         
         if(d>0){
            UpperValue[i]=usum/d;
         }
      //}      
      
      //    
      //if(BothBuferCount[i]>=AverPeriod){
      
         d=0;
         z=(int)(Bars-BothBuferCount[i]);
         p=z+AverPeriod;
         bsum=0;
         
         if(!AfterCross){ //        
            if(LastDir[i]==1){ //     
               if(UpperMax[i]>=Point*Delta){
                  bsum=UpperMax[i]; //  
                  p--; //    
                  d++;
               }
            }
            else if(LastDir[i]==-1){ //     
               if(LowerMax[i]>=Point*Delta){
                  bsum=LowerMax[i]; //  
                  p--; //    
                  d++;
               }
            }
         }             
         
         p=MathMin(Bars,p);
         for(int j=z;j<p;j++){
            bsum+=BothBufer[j];
            d++;
         }
         
         if(d>0){
            BothValue[i]=bsum/d;
         }
      //}   

   }      

   return(rates_total);
  }
//+------------------------------------------------------------------+
